#synch_s.py
from mpi4py import MPI
import numpy as np

comm = MPI.COMM_WORLD
nproc = comm.Get_size()
myid = comm.Get_rank()

sbuf = np.ones(1)
rbuf = np.empty(1)
t0 = MPI.Wtime() 
# on task 0 receive messages from all other tasks
# then send messages from task 0 to all other tasks
#   syntax:
#      comm.Ssend(sbuf,dest=taskid)
#      comm.Recv(rbuf,source=taskid)

dt = MPI.Wtime() - t0
tdmax=comm.reduce(dt,MPI.MAX)


if myid == 0:
   print ("Barriere fuer %i Prozessoren dauert: %e" %(nproc, tdmax))
   print ("Das sind %e Zyklen" % (tdmax*2400.0e+6))
