from mpi4py import MPI
import math
import time
import numpy as np
from dist_index import dist_index 
comm = MPI.COMM_WORLD
nproc= comm.Get_size()
myid = comm.Get_rank()

def dist_matrix_colblock( n, nl, a ):
   al = np.empty((n*nl))
   if myid == 0:
      firstind = dist_index(n)
      for ip in range(nproc):
         ia = firstind[ip]
         ie = firstind[ip+1]
         nl = ie -ia
         if ip == 0:
            al = a[ia*n:ie*n]
         else:
            comm.Send(a[ia*n:ie*n], dest= ip)
   else:
      comm.Recv(al, source=0)
   return al

