from mpi4py import MPI
import math 
import numint_module

def f(x):
      return math.sqrt(1.-x*x)

def farmer(idle,ndom):
   comm = MPI.COMM_WORLD
   nproc= comm.Get_size()
   ipfa = comm.Get_rank()
   tag_fa = 0; tag_wo = 1; tag_cl = 2
   for iw in range( 1,ndom+1):
      ipw = comm.recv(source=MPI.ANY_SOURCE, tag=tag_wo)
      comm.send(iw, dest=ipw, tag=tag_fa)
#      print (" send iw %i to process %i" % (iw,ipw)
   pia = 0.
   for ipw in range( nproc):
      if (ipw == ipfa) & (idle == 0) :
         continue
      comm.send(ndom+1, dest=ipw, tag=tag_fa)
      pial = comm.recv(source=ipw, tag=tag_cl)
#      print("from %i: %f " %(ipw,pial))
      pia = pia + pial
#   print("from farmer: %f " %(pia))
   return (pia)

def worker(ipfa,n,ndom):
   comm = MPI.COMM_WORLD
   ipwo = comm.Get_rank()
   tag_fa = 0; tag_wo = 1; tag_cl = 2
   width = 1./ndom
   comm.send(ipwo, dest= ipfa,tag=tag_wo)
   pia = 0.; ta = 0.
   for i in range( 1,ndom+2):
      iw = comm.recv(source=ipfa, tag=tag_fa)
      if iw > ndom :
         break
      lo = 1.0 - iw*width
      hi = lo + width
      nl = int(n * (f(lo) - f(hi)))+1
      delt = (hi-lo)/nl
      t = MPI.Wtime()
      pia = numint_module.numint(lo, delt, nl, pia)
      ta = ta + MPI.Wtime()-t
      comm.send(ipwo, dest=ipfa, tag=tag_wo)
   print (" process %i:  %i domains in %f sec" % (ipwo,i-1,ta))
   comm.send(pia, dest=ipfa, tag=tag_cl)
   return

