from numba.pycc import CC
from numba import njit, f8
import math

@njit(f8(f8))
def f(x):
      return math.sqrt(1.-x*x)

cc = CC('numint_module')
@cc.export('numint', 'f8(f8,f8,i4,f8)')
def numint(lo,delt,nl,pia):
      su = 0.0
      for i in range(0,nl):
         xi = lo + (i+0.5)*delt
         su = su +  f(xi)
      return (pia + 4.*delt*su)

if __name__ == "__main__":
    cc.compile()
