import time
import numint_module
import math

def f(x):
   return math.sqrt(1.-x*x)

piexact = 3.14159265358979323846264338327950288419
n = int(input('number of strips ?   '))
ndom = int(input('number of intervals ?   '))
print (" calculation of pi using numerical integration of sqrt(1-x**2)") 
print (" number of strips         : %i" % n) 
print (" number of subintervals   : %i" % ndom)
t = time.time()
width = 1./ndom
pia = 0.
for i in range(ndom) :
   t1 = time.time()
   lo = width*i
   hi = lo + width 
   nl = int(n*(f(lo)-f(hi)))+1
   delt = (hi-lo)/nl
   pia = numint_module.numint(lo,delt,nl,pia)
   t1 = time.time() - t1
   print (" domain %i with %8i strips in %5.2e s " %(i,nl,t1))
t = time.time() - t
r = n/t*0.000001
print (" pi exact          = %20.15f" % piexact)
print (" pi estimated      = %20.15f \n" % pia)
print (" error             = %20.3e \n" % abs(pia-piexact))
print (" time[s], rate[Mstrips/s] : %10.5f,    %5.2e\n" % (t, r)) 
