from mpi4py import MPI
from agents import worker, farmer

# =========== main program for farmer-worker calculation
comm = MPI.COMM_WORLD
nproc= comm.Get_size()
me = comm.Get_rank()
ipfa = 0; idle = 0; pia = 0.; n=0; ndom=0
if me == ipfa:
   piexact = 3.14159265358979323846264338327950288419
   n = int(input('number of strips ?   '))
   ndom = int(input('number of intervals ?   '))
   print (" calculation of pi using numerical integration of sqrt(1-x**2)")
   print (" number of strips      : %i" % n)
   print (" number of subintervals   : %i" % ndom)
n = comm.bcast(n, root= ipfa)
ndom = comm.bcast(ndom, root= ipfa)
# ============  Worker-Teil (me!=ipfa) =======================
if me != ipfa:
   comm.barrier()
   worker(ipfa,n,ndom)   
# ============  Farmer-Teil (me=ipfa) =======================
if me == ipfa:
   comm.barrier()
   t = MPI.Wtime()
   pia = farmer(idle,ndom)
   t = MPI.Wtime()-t
   r = n/t*1.e-6
   print ('Naeherung fuer pi =     %20.10f '% pia)
   print ('error     %20.3e  '% abs(piexact-pia))
   print (" time[s], rate[Mstrips/s] : %10.5f,    %5.2e\n" % (t, r))
